/*
 * C872File.h
 *
 *  Created on: Feb 11, 2011
 *      Author: Joel Vidal
 */

#ifndef C872FILE_H_
#define C872FILE_H_

#include <iostream>
#include <fstream>
#include <ctime>
#include <sys/time.h>
#include <cstring>
#include <cmath>
using namespace std;


class C872File {
public:

	typedef unsigned char Byte;

	void
	open(char* filename);

	void
	inputData(char* portData,
			  char* starBoardData,
			  Byte freq,
			  Byte range,
			  Byte dataGain,
			  char* headerBuffer);

	void
	close();

	C872File();

	virtual ~C872File();



private:

	  ofstream outFile_;
	  unsigned int pingNumber_;
	  int repRate_;
	  double currentTime_, lastTime_;

};

#endif /* C872FILE_H_ */
