/*
 * CSideScanSonar.cpp
 *
 *  Created on: Feb 11, 2011
 *      Author: Joel Vidal
 */

#include "CSideScanSonar.h"



void
CSideScanSonar::runEndless()
{

	int nBytes;
	int i;
	char buffer[1014]; //1014 es perque a la pos 1013 i posem /0
	char portData[1000];
	char starboardData[1000];
	char headerBuffer[12];


	//Entrem dades Switch Data Command
	SDC_.header1 	= 	0xFE;	//Byte0, 0xFE
	SDC_.header2 	= 	0x44;	//Byte1, 0x44
	SDC_.resvd1 	= 	0;		//Byte2,
	SDC_.range 		= 	10;		//Byte3, Range
	SDC_.resvd2 	= 	0;		//Byte4,
	SDC_.resvd3 	= 	0;		//Byte5,
	SDC_.masterSlave= 	0;		//Byte6,
	SDC_.freq 		= 	0;		//Byte7, Freq - 0: Low, 1: Medium, 2: High
	SDC_.dataGain 	= 	10;		//Byte8, Data Gain
	SDC_.resvd4 	= 	0;		//Byte9,
	SDC_.balanceGain= 	30;		//Byte10, Balance Gain
	SDC_.resvd5 	= 	0;		//Byte11,
	SDC_.resvd6 	= 	0;		//Byte12,
	SDC_.resvd7 	= 	0;		//Byte13,
	SDC_.resvd8 	= 	0;		//Byte14,
	SDC_.resvd9 	= 	0;		//Byte15,
	SDC_.resvd10 	= 	0;		//Byte16,
	SDC_.resvd11 	= 	0;		//Byte17,
	SDC_.packNumber = 	0;		//Byte18, Packet Number
	SDC_.resvd12 	= 	0;		//Byte19,
	SDC_.resvd13 	= 	0;		//Byte20,
	SDC_.resvd14 	= 	0;		//Byte21,
	SDC_.resvd15 	= 	0;		//Byte22,
	SDC_.resvd16 	= 	0;		//Byte23,
	SDC_.resvd17 	= 	0;		//Byte24,
	SDC_.resvd18 	= 	0;		//Byte25,
	SDC_.term 		= 	0xFD;	//Byte26, 0xFD

	//Inicializtem parametres de canvi
	freqChange_ = SDC_.freq;
	rangeChange_ = SDC_.range;


	std::cout << "> Parametres inicialitzats." << std::endl;

	//Obrim fitxer
	saveFile_.open( "Prova" );
	std::cout << "> Fitxer obert." << std::endl;

	//Conectar
	ethernetConnection_.connect( IPSonar_, portSonar_ );

	std::cout << "> Conexió realitzada." << std::endl;
	std::cout << "> Inici captura sonar." << std::endl;

	while( true ){ //Infinitament

		//Enviem SDC_
		ethernetConnection_.send( ( char* )&SDC_, 27 );

		//Esperem Resposta
		nBytes=1013;
		ethernetConnection_.receive( buffer, nBytes );


		//Comprovem que sigui un missatge del sonar // | buffer[1013]!= 0x0FC
		if ( buffer[0] != 'I' | buffer[1] != 'V' | buffer[2] != 'X' )
			throw std::runtime_error( "Not a sidescan sonar package" );


		//Canviem el numero de packet (2-0,0-2) i Actualitzem fitxer
		if ( SDC_.packNumber == 0 ){
			//Save port data
			for ( i = 0; i < 1000; i++ )
				portData[i] = buffer[i + 12];

			//Canviem numero de paquet
			SDC_.packNumber = 2;
		}
		else {
			//Save starboard data
			for ( i = 0; i < 1000; i++ )
				starboardData[i] = buffer[i + 12];

			//Save Header
			for ( i = 0; i < 12; i++ )
				headerBuffer[i] = buffer[i];

			//Update save file
			saveFile_.inputData( portData, starboardData, SDC_.freq,
								 SDC_.range, SDC_.dataGain, headerBuffer );

			//Canviem valor de rang, freq..
			SDC_.range = rangeChange_;
			SDC_.freq = freqChange_;

			//Canviem numero de paquet
			SDC_.packNumber = 0;
		}
	}
}



CSideScanSonar::CSideScanSonar()
:
	ethernetConnection_(),
	saveFile_(),
	IPSonar_("192.168.0.7"),
	portSonar_(4040)

{
	// TODO Auto-generated constructor stub
}



CSideScanSonar::~CSideScanSonar() {
	// TODO Auto-generated destructor stub
}

