/*
 * CSideScanSonar.h
 *
 *  Created on: Feb 11, 2011
 *      Author: Joel Vidal
 */

#ifndef CSIDESCANSONAR_H_
#define CSIDESCANSONAR_H_


#include <string>
#include <ostream>
#include "CEthernetTest.h"
#include "C872File.h"
using namespace std;


class CSideScanSonar {
public:

	/*
	 * Executa infinitament, Parametres per defecta
	 */
	void
	runEndless();

	CSideScanSonar();

	virtual ~CSideScanSonar();


private:

	typedef unsigned char Byte;

	struct SwitchDataCommand{
			Byte header1;		//Byte0, 0xFE
			Byte header2;		//Byte1, 0x44
			Byte resvd1;		//Byte2,
			Byte range;			//Byte3,
			Byte resvd2;		//Byte4,
			Byte resvd3;		//Byte5,
			Byte masterSlave;	//Byte6,
			Byte freq;			//Byte7,
			Byte dataGain;		//Byte8,
			Byte resvd4;		//Byte9,
			Byte balanceGain;	//Byte10,
			Byte resvd5;		//Byte11,
			Byte resvd6;		//Byte12,
			Byte resvd7;		//Byte13,
			Byte resvd8;		//Byte14,
			Byte resvd9;		//Byte15,
			Byte resvd10;		//Byte16,
			Byte resvd11;		//Byte17,
			Byte packNumber;	//Byte18, packet number
			Byte resvd12;		//Byte19,
			Byte resvd13;		//Byte20,
			Byte resvd14;		//Byte21,
			Byte resvd15;		//Byte22,
			Byte resvd16;		//Byte23,
			Byte resvd17;		//Byte24,
			Byte resvd18;		//Byte25,
			Byte term;			//Byte26, 0xFD
	};

	std::string IPSonar_;
	int portSonar_;

	CEthernetTest ethernetConnection_;
	SwitchDataCommand SDC_;
	C872File saveFile_;

	int rangeChange_;
	int freqChange_;
};

#endif /* CSIDESCANSONAR_H_ */

