%Netejem les variables
clear;

%Canviem el format de les variables a long
format long;

disp('Selecciona el log del sonar');
%Busquem el fitxer del sonar
[filename, pathname] = uigetfile('*.log');
logS = strcat(pathname,filename);

%Carraguem el log del sonar
[dadesImg,nFImg,nCImg] = openLog(logS);

%Comprovem que l'arxiu sigui correcte
if (nFImg < 10 || nCImg ~= 2011) 
    error('Arxiu incorrecte');
end

disp('Selecciona el log del navegador');
%Busquem el fitxer del sonar
[filename, pathname] = uigetfile('*.log');
logN = strcat(pathname,filename);

%Carraguem el log del sonar
[dadesNav,nFNav,nCNav] = openLog(logN);

%Comprovem que l'arxiu sigui correcte
if (nFNav < 10 || nCNav ~= 43) 
    error('Arxiu incorrecte');
end


%Mostrem en nom del fitxers selleccionats
fprintf('\nNOM DEL FITXERS:\n');
disp(logS);
disp(logN);

%Mostrem els parametres de la captura
fprintf('\nDADES:');
fprintf('\nRang: %d m', dadesImg(2,9));

if (dadesImg(2,10) == 0)
    freq = 260;
elseif (dadesImg(2,10) == 1)
    freq = 330;
else
    freq = 770;
end

fprintf('\nFreqencia: %d kHz', freq);
fprintf('\nGuany: %d dB', dadesImg(2,11));
fprintf('\nResoluci: %f\n\n', dadesImg(2,9)/1000);

%Separem la data i la posici en matrius diferents
navDate = dadesNav(:,1:7);
navPos = dadesNav(:,8:10);

%Inicialitzar variables
i = 1;
pos2 = navPos(i,1:2);
imgPos = 1;
dist = 0;
rang = dadesImg(2,9);
%FactResol s el factor pel qual es multiplicaran les distancies per
%aconseguir que l'eix oritzontal i vertical de la imatge final
%utilitzin la mateixa escala
factResol = 1000/rang;

%Per cada linia imatge sonora
for pos=1:nFImg

    %Obtenim la data de la imatge
    imageDate = dadesImg(pos:pos,1:7);
       
    %Calculem la posici en que s'ha capturat la imatge lineal
    %buscant l'interval de temps ms petit entre la captura de
    %la imatge i la captura de la posici
    intervalMinVal = msInterval(imageDate,navDate(i,:));
    if (i < nFNav)
      intervalVal =  msInterval(imageDate,navDate(i + 1,:));   
        while (i < nFNav) && (intervalMinVal >= intervalVal) 
            intervalMinVal = intervalVal ;
            i = i + 1;
            if (i < nFNav)
                intervalVal = msInterval(imageDate,navDate(i + 1,:));
            end
        end
    end
    
    %Guardem la posici on s'ha capturat la imatge
    pos1 = navPos(i,1:2);
    
    
    %Calculem la distancia respecta l'ultima imatge linwal que es va pintar 
    %a la imatge final
    dist = dist + sqrt((pos1(1)-pos2(1))^2 + (pos1(2)-pos2(2))^2) * factResol;
 
    %Si la distancia s ms gran que 1 pintar la imatge lineal
    %Si no, continuar
    if dist >= 1
        
         %Obtenim la imatge
        imageLinear = dadesImg(pos:pos,12:nCImg);
        
        %Pintar a la imatge final aquesta imatge lineal
    
        for j=int32(imgPos):int32(imgPos + dist - 1) %-1
            imageBuffer(j,1:1000) = imageLinear(1000:-1:1); %Babord
            imageBuffer(j,1001:2000) =imageLinear(1001:2000); %Estribord
        end
        
        %En cas que s'hagi pintat la imatge final es suma la distancia
        %pintada a la variable imgPos i es deixa la distancia a 0
        imgPos = imgPos + dist;
        dist = 0;
    end
     
    pos2 = pos1; 
    
end

colormap( gray ) ;
imwrite(imageBuffer/255, 'resultat.bmp')
